on startMovie
  openXLib(the pathName & "V12dbe")
  openXLib(the pathName & "V12table")
  set the floatPrecision to 2
end

on stopMovie
  global gDb, gTable
  if objectp(gTable) then
    set gTable to 0
  end if
  if objectp(gDb) then
    set gDb to 0
  end if
end

on initStuff
  global gDb, gTable
  set gTable to 0
  set gDb to 0
  set DBfact to xtra("V12dbe")
  set gDb to new(DBfact, the pathName & "catalog.V12", "ReadWrite", "top secret")
  if not objectp(gDb) then
    alert("Cannot create Database instance. Err=" && gDb)
    exit
  end if
  set TBfact to xtra("V12table")
  set gTable to new(TBfact, mGetRef(gDb), "articles")
  if not objectp(gTable) then
    alert("Cannot create V12table instance. Err=" && gDb)
  end if
end

on showSelection
  global CDXTable
  set n to mSelectCount(CDXTable)
  set temp to mGetPosition(CDXTable)
  mGoFirst(CDXTable)
  put EMPTY into field "selection"
  set dummy to EMPTY
  repeat with i = 1 to n
    set nm to mGetField(CDXTable, "CD_PROD")
    set prc to mGetField(CDXTable, "CD_ISSUE")
    set catNum to mGetField(CDXTable, "CD_CAT")
    mGoNext(CDXTable)
  end repeat
end

on updateDisplay
  global gTable
  set i to mGetPosition(gTable)
  set the foreColor of field "selection" to 176
  set the foreColor of line i of field "selection" to 35
  put mGetField(gTable, "name") into field "name"
  put mGetField(gTable, "price") into field "price"
  put mGetField(gTable, "description") into field "description"
  put mGetField(gTable, "catalog number") into field "catalog"
  put mGetField(gTable, "category") into field "category"
end

on domSelectCount
  global gTable
  put mSelectCount(gTable) into field "totalCount"
end

on doNext
  global gTable
  set err to mGoNext(gTable)
  CheckError(err, "doNext")
  updateDisplay()
end

on doPrevious
  global gTable
  set err to mGoPrevious(gTable)
  CheckError(err, "doPrevious")
  updateDisplay()
end

on doFirst
  global gTable
  set err to mGoFirst(gTable)
  CheckError(err, "doFirst")
  updateDisplay()
end

on doLast
  global gTable
  set err to mGoLast(gTable)
  CheckError(err, "doLast")
  updateDisplay()
end

on doAddRecord
  global gTable
  set err to mAddRecord(gTable)
  if err = 0 then
    EditMode(1)
  end if
  CheckError(err, "addRecord")
end

on doEditRecord
  global gTable
  set err to mEditRecord(gTable)
  if err = 0 then
    EditMode(1)
  end if
  CheckError(err, "editRecord")
end

on doUpdateRecord
  global gTable
  set err to mSetField(gTable, "name", field "name")
  CheckError(err, "mSetField name")
  set err to mSetField(gTable, "price", field "price")
  CheckError(err, "mSetField price")
  set err to mSetField(gTable, "description", field "description")
  CheckError(err, "mSetField description")
  set err to mSetField(gTable, "catalog number", field "catalog")
  CheckError(err, "mSetField catalog number")
  set err to mSetField(gTable, "category", field "category")
  CheckError(err, "mSetField category")
  set err to mUpdateRecord(gTable)
  if err = 0 then
    EditMode(0)
  end if
  CheckError(err, "updateRecord")
  showSelection()
end

on doDeleteRecord
  global gTable
  set err to mDeleteRecord(gTable)
  CheckError(err, "deleteRecord")
  showSelection()
end

on doSetIndex ndx
  global gTable
  set err to mSetIndex(gTable, ndx)
  CheckError(err, "mSetIndex " & ndx)
  set err to mSelect(gTable)
  CheckError(err, "mSelect")
  showSelection()
end

on doSetCriteria
  global gTable
  set err to mSetCriteria(gTable, field "fld", field "op", field "value")
  CheckError(err, "mSetCriteria #1")
  if (field "bool" = "and") or (field "bool" = "or") then
    set err to mSetCriteria(gTable, field "bool", field "fld2", field "op2", field "value2")
    CheckError(err, "mSetCriteria #2")
    if (field "bool2" = "and") or (field "bool2" = "or") then
      set err to mSetCriteria(gTable, field "bool2", field "fld3", field "op3", field "value3")
      CheckError(err, "mSetCriteria #3")
    end if
  end if
end

on doOrderBy
  global gTable
  set err to mOrderBy(gTable, field "SortFld")
  CheckError(err, "mOrderBy")
end

on doSelect
  global gTable
  set err to mSelect(gTable)
  CheckError(err, "mSelect")
  showSelection()
end
